org.apache.lucene.search.spans

## Class SpanWeight

- java.lang.Object
- - org.apache.lucene.search.Weight
  - - org.apache.lucene.search.spans.SpanWeight

- Direct Known Subclasses:
    org.apache.lucene.search.spans.SpanContainQuery.SpanContainWeight, SpanNearQuery.SpanNearWeight, SpanNotQuery.SpanNotWeight, SpanOrQuery.SpanOrWeight, SpanPositionCheckQuery.SpanPositionCheckWeight, SpanTermQuery.SpanTermWeight

      public abstract class SpanWeight
      extends Weight

  Expert-only. Public for use by other weight implementations

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SpanWeight.Postings` Enumeration defining what postings information should be retrieved from the index for a given Spans

    - ### Nested classes/interfaces inherited from class org.apache.lucene.search.Weight

      `Weight.DefaultBulkScorer`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `field`
    `protected Similarity` | `similarity`
    `protected Similarity.SimWeight` | `simWeight`

    - ### Fields inherited from class org.apache.lucene.search.Weight

      `parentQuery`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SpanWeight(SpanQuery query, IndexSearcher searcher, Map<Term,TermContext> termContexts)` Create a new SpanWeight

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Explanation` | `explain(LeafReaderContext context, int doc)` An explanation of the score computation for the named document.
    `abstract void` | `extractTermContexts(Map<Term,TermContext> contexts)` Collect all TermContexts used by this Weight
    `Similarity.SimScorer` | `getSimScorer(LeafReaderContext context)` Return a SimScorer for this context
    `abstract Spans` | `getSpans(LeafReaderContext ctx, SpanWeight.Postings requiredPostings)` Expert: Return a Spans object iterating over matches from this Weight
    `float` | `getValueForNormalization()` The value for normalization of contained query clauses (e.g.
    `void` | `normalize(float queryNorm, float boost)` Assigns the query normalization factor and boost to this.
    `SpanScorer` | `scorer(LeafReaderContext context)` Returns a `Scorer` which can iterate in order over all matching documents and assign them a score.

    - ### Methods inherited from class org.apache.lucene.search.Weight

      `bulkScorer, extractTerms, getQuery`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### similarity

          protected final Similarity similarity

    - #### simWeight

          protected final Similarity.SimWeight simWeight

    - #### field

          protected final String field

  - ### Constructor Detail

    - #### SpanWeight

          public SpanWeight(SpanQuery query,
                    IndexSearcher searcher,
                    Map<Term,TermContext> termContexts)
                     throws IOException

      Create a new SpanWeight
      Parameters:
        `query` - the parent query
        `searcher` - the IndexSearcher to query against
        `termContexts` - a map of terms to termcontexts for use in building the similarity. May be null if scores are not required
      Throws:
        `IOException` - on error

  - ### Method Detail

    - #### extractTermContexts

          public abstract void extractTermContexts(Map<Term,TermContext> contexts)

      Collect all TermContexts used by this Weight
      Parameters:
        `contexts` - a map to add the TermContexts to

    - #### getSpans

          public abstract Spans getSpans(LeafReaderContext ctx,
                       SpanWeight.Postings requiredPostings)
                                  throws IOException

      Expert: Return a Spans object iterating over matches from this Weight
      Parameters:
        `ctx` - a LeafReaderContext for this Spans
        `requiredPostings` - the postings information required
      Returns:
        a Spans
      Throws:
        `IOException` - on error

    - #### getValueForNormalization

          public float getValueForNormalization()
                                         throws IOException

      Description copied from class: `Weight`
      The value for normalization of contained query clauses (e.g. sum of squared weights).
      Specified by:
        `getValueForNormalization` in class `Weight`
      Throws:
        `IOException`

    - #### normalize

          public void normalize(float queryNorm,
                       float boost)

      Description copied from class: `Weight`
      Assigns the query normalization factor and boost to this.
      Specified by:
        `normalize` in class `Weight`

    - #### scorer

          public SpanScorer scorer(LeafReaderContext context)
                            throws IOException

      Description copied from class: `Weight`
      Returns a `Scorer` which can iterate in order over all matching documents and assign them a score.

      NOTE: null can be returned if no documents will be scored by this query.

      NOTE: The returned `Scorer` does not have `LeafReader.getLiveDocs()` applied, they need to be checked on top.

      Specified by:
        `scorer` in class `Weight`
      Parameters:
        `context` - the `LeafReaderContext` for which to return the `Scorer`.
      Returns:
        a `Scorer` which scores documents in/out-of order.
      Throws:
        `IOException` - if there is a low-level I/O error

    - #### getSimScorer

          public Similarity.SimScorer getSimScorer(LeafReaderContext context)
                                            throws IOException

      Return a SimScorer for this context
      Parameters:
        `context` - the LeafReaderContext
      Returns:
        a SimWeight
      Throws:
        `IOException` - on error

    - #### explain

          public Explanation explain(LeafReaderContext context,
                            int doc)
                              throws IOException

      Description copied from class: `Weight`
      An explanation of the score computation for the named document.
      Specified by:
        `explain` in class `Weight`
      Parameters:
        `context` - the readers context to create the `Explanation` for.
        `doc` - the document's id relative to the given context's reader
      Returns:
        an Explanation for the score
      Throws:
        `IOException` - if an `IOException` occurs

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.